import 'package:flutter/material.dart';
import 'widgets/webview.dart';

class FlutterMytransporter extends StatefulWidget {
  /*

      MyTransporter Main Flutter wrapper
      params:
          merchantKey:String
          email: String
          firstName: String?
          lastName: String?
          onCancel: Function
          onVerified: Function
          onError: Function
          buttonText: Text?
          customButton: ElevatedButton?

  */

  //Merchant public key
  final String publicKey;

  //user email
  final String email;

  //user first name - optional
  final String firstName;

  //user last name - optional
  final String lastName;

  //user last name - optional
  final double pickupLatitude;

  //user last name - optional
  final String pickupLocation;

  //user last name - optional
  final double pickupLongitude;

  //user last name - optional
  final String phone;

  //on verification cancelled callback
  final Function onCancel;

  //on verification successfull calback
  final Function onTransport;

  // on error callback
  final Function onError;

  //text to appear on button
  final Text? buttonText;

  ///custom button design
  final ElevatedButton? customButton;

  FlutterMytransporter(
      {required this.publicKey,
      required this.email,
      required this.firstName,
      required this.lastName,
      required this.pickupLatitude,
      required this.pickupLongitude,
      required this.pickupLocation,
      required this.phone,
      required this.onCancel(response),
      required this.onTransport(response),
      this.customButton,
      this.buttonText,
      required this.onError(error)});

  @override
  FlutterMytransporterState createState() => FlutterMytransporterState();
}

class FlutterMytransporterState extends State<FlutterMytransporter> {
  void showModal() {
    /*
       pass data to modal and display webview component
    */

    Navigator.of(context).push(MyTransporterWebView(
        publicKey: widget.publicKey,
        firstName: widget.firstName,
        lastName: widget.lastName,
        email: widget.email,
        pickupLatitude: widget.pickupLatitude,
        pickupLocation: widget.pickupLocation,
        pickupLongitude: widget.pickupLongitude,
        phone: widget.phone,
        onCancel: widget.onCancel,
        onError: widget.onError,
        onTransport: widget.onTransport));
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: Center(
        child: ElevatedButton(
          style: null,
          onPressed: showModal,
          child: widget.buttonText != null
              ? widget.buttonText
              : Text('INITIATE TRANSPORT'),
        ),
      ),
    );
  }
}
